/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

import{Exception as e,Base62 as t,ObjectId as i,Sequence as s,Resolvable as r,CreateHashedObjectId as o}from"@agentframework/app";import{HttpError as n,MaliciousRequestError as a,ApplicationError as d,Secret as p,ParameterError as c,AuthenticationError as l,WebRequestIdentity as g,WebApplicationIdentity as y,WebApplication as u,MakeCookieHeaders as h,WebApplicationSettings as f,method as m,controller as E}from"@agentframework/web";import{ClassInitializer as _,transit as S,singleton as I}from"@agentframework/domain";import{Readable as v}from"stream";import{normalize as O,sep as b,isAbsolute as x,join as N,resolve as C,parse as w,extname as R,basename as F}from"path";import{statSync as A,createReadStream as T}from"fs";import{isIP as k}from"net";import{Root as B}from"protobufjs";import{property as L,model as P,Model as D,RecordCollection as M}from"@agentframework/data";import"url";function U(e,t,i,s){var r,o=arguments.length,n=o<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,i):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,s);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(n=(o<3?r(n):o>3?r(t,i,n):r(t,i))||n);return o>3&&n&&Object.defineProperty(t,i,n),n}function W(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}let H;const j=new RegExp(/^text\/html/);function q(t,i,s={}){const r=O(C(s.root||t.settings.PUBLIC_DIR)),o="/"===(i=i||"/")[i.length-1];i=i.substr(w(i).root.length);const n=s.index||"index.html",p=s.maxAge||t.settings.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS;i=function(t){try{return decodeURIComponent(t)}catch(t){throw new e(t,"failed to decode")}}(i),o&&(i+=n);const c=function(e,t){if(-1!==t.indexOf("\0"))throw new a("NULL is not allowed in request path");if(H||(H=/(?:^|[\\\/])\.\.(?:[\\\/]|$)/),H.test(O("."+b+t)))throw new a("Up path (../) is not allowed in request path");if(x(t))throw new a("Absolute path is not allowed");return O(N(C(e),t))}(r,i);if(function(e,t){const i=t.substr(e.length).split(b);if(".well-known"===i[0])return!1;for(let e=0;e<i.length;e++)if("."===i[e][0])return!0;return!1}(r,c))return!1;let l;try{if((l=A(c)).isDirectory())return!1}catch(e){if(~["ENOENT","ENAMETOOLONG","ENOTDIR"].indexOf(e.code))return!1;throw new d(e,"Unable to access requested file")}t.logger.update({sz:(l.size/1024).toFixed(1)});const g=t.res;var y,u;return g.lastModified||(g.lastModified=l.mtime),g.status=200,g.length=l.size,g.type=(y=c,"."===(u=R(""!==(u="")?F(y,u):y))[0]?u.slice(1):u),g.hasHeader("x-content-type-options")||g.setHeader("x-content-type-options","nosniff"),p>0?g.hasHeader("cache-control")||g.setHeader("cache-control","public, max-age="+p):(g.hasHeader("pragma")||g.setHeader("pragma","no-cache"),g.hasHeader("cache-control")||g.setHeader("cache-control","no-cache, no-store, must-revalidate")),g.type.match(j)&&(t.settings.DEBUG||g.setHeader("strict-transport-security","max-age=31536000; includeSubDomains"),Array.isArray(t.settings.WEB_CONTENT_SECURITY_POLICY)&&g.setHeader("content-security-policy",t.settings.WEB_CONTENT_SECURITY_POLICY.join(" ")),g.setHeader("x-frame-options","SAMEORIGIN"),g.setHeader("x-xss-protection","1")),g.body=T(c),t.state.silent=!0,{file:c,type:g.type,length:l.size}}class IdentityCookieHelper{static get(e){const t=e.cookies.getAll(e.settings.WEB_DEVICE_COOKIE_KEY);if(t)return t[t.length-1]}static set(e,t){const i=e.settings.WEB_DEVICE_COOKIE_DOMAIN||e.hostname,s=e.settings.WEB_DEVICE_COOKIE_KEY,r={path:"/",httpOnly:!0,maxAge:e.settings.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS,secure:!e.settings.DEBUG};if(k(i))e.res.cookies.add(s,t,Object.assign({domain:i},r));else{const o=i.split(".");1===o.length&&e.res.cookies.add(s,t,Object.assign({domain:i},r)),o.length>1&&e.res.cookies.add(s,t,Object.assign({domain:o.slice(-2).join(".")},r)),o.length>2&&e.res.cookies.add(s,t,Object.assign({domain:o.slice(-3).join(".")},r))}return t}}class IdentityHelper{static getIdentityId(e){return this.verify(IdentityCookieHelper.get(e))}static createIdentityId(e){const s=this.sign(t.fromBuffer((new i).id));return e.state.new_device_id=s,e.logger.update({new_device:1}),IdentityCookieHelper.set(e,s)}static createIdentityAddress(e){const t=e.ip;let i=((t&&t.indexOf(":"))>=0?"/ip6/":"/ip4/")+t;const s=e.getHeader("x-forwarded-port");return s&&(i+="/tcp/"+s),i}static crc(e){let i=0;for(let t=0;t<e.length;t++)i+=e.charCodeAt(t);return t.singleton.alphabet[i%62]}static sign(e){return this.crc(e)+e}static verify(e){if(!e)return e;const t=e.slice(1),i=this.crc(t);return e[0]===i?t:void 0}}class SHA512{static sign(e,i){const s=new p(e.settings.SECRET_KEYS,"sha512").sign(i);return t.fromBuffer(i)+"."+t.fromBuffer(s)}static verify(e,i){const s=i.indexOf(".");if(s>0&&s<i.length){const s=new p(e.settings.SECRET_KEYS,"sha512");try{const e=i.split("."),r=t.toBuffer(e[0]),o=t.toBuffer(e[1]);return!!s.verify(r,o)&&r}catch(e){return!1}}return!1}}class SessionCookieHelper{static get(e){const t=e.cookies.get(e.settings.WEB_SESSION_COOKIE_KEY);if(t&&t.length>40){const i=SHA512.verify(e,t);if(i)return i;e.logger.warn({id:e.ip,cookie:t},"[INTRUSION DETECTED] User sent invalidate auth token:")}return null}static set(e,t){const i={path:"/api",httpOnly:!0,secure:!e.settings.DEBUG};e.res.cookies.add(e.settings.WEB_SESSION_COOKIE_KEY,SHA512.sign(e,t),i)}static clear(e){const t={path:"/api",httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,"",t)}}class SessionProtocol{static get schema(){const e=B.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:"bytes",id:1},id:{type:"string",id:2},displayName:{type:"string",id:3},displayImageURL:{type:"string",id:4}}},WebSession:{fields:{session:{type:"string",id:1},user:{type:"string",id:2},token:{type:"string",id:3},roles:{type:"string",rule:"repeated",id:4},groups:{type:"string",rule:"repeated",id:5},scope:{type:"string",rule:"repeated",id:6},profile:{type:"IdentityProfile",id:7},timezone:{type:"string",id:8},locale:{type:"string",id:9},theme:{type:"string",id:10}}}}}).lookupType("WebSession");return Reflect.defineProperty(this,"schema",{value:e}),e}static encode(e){return this.schema.encode(e).finish()}static decode(e,t={}){let i;try{i=this.schema.decode(e)}catch(e){return null}for(const e of this.SessionFields)t[e]=i[e];if(i.profile){const e=t.profile||{};Object.assign(e,{_id:i.profile._id,id:i.profile.id,displayName:i.profile.displayName,displayImageURL:i.profile.displayImageURL}),t.profile=e}return t}}SessionProtocol.SessionFields=["session","user","token","roles","groups","scope","profile","theme","timezone","locale"];class SessionHelper{static load(e,t){const i=SessionCookieHelper.get(e);i&&i.length&&SessionProtocol.decode(i,t)}static save(e,t){if(!t||!Object.keys(t).length)throw new c("Unable to update empty identity, please use WebIdentityService.clear() instead");const i=SessionProtocol.encode(t);if(!i||!i.byteLength)throw new l("Invalid session data (byteLength=0)");SessionCookieHelper.set(e,i)}static clear(e){for(const t of Object.keys(e.identity))"id"!==t&&"address"!==t&&delete e.identity[t];SessionCookieHelper.clear(e)}}class WebFoundationRequestIdentity extends g{static[_](e,t){const s=new WebFoundationRequestIdentity;if(s.id=IdentityHelper.getIdentityId(e)||IdentityHelper.createIdentityId(e),s.address=IdentityHelper.createIdentityAddress(e),e.path.startsWith("/api")){const t={};if(SessionHelper.load(e,t),t&&t.session){new i(t.session).getTimestamp()>new Date&&Object.assign(s,t)}}return s.theme=s.theme||e.settings.THEME,s.locale=s.locale||e.settings.LOCALE,s.timezone=s.timezone||e.settings.TIMEZONE,s}}class WebFoundationApplicationIdentity extends y{static[_](e){const t=new WebFoundationApplicationIdentity;return console.log("create app identity",e),t}}class WebFoundationApplication extends u{addMiddleware(e){this.middleware.push(e)}invoke(e){return this.middleware.compose(e)}onInit(){const t=this;this.addType(WebFoundationRequestIdentity),this.addType(WebFoundationApplicationIdentity),this.addMiddleware(function(t,i){return i().then(async i=>{null!=i&&t.logger.warn({result:i},"Return value from middleware is been ignored"),t.req.performance.log("router","[[End]]");let s,{total:r,header:o}=t.req.performance.build(t.settings.NAME);t.res.headers.set("x-response-time",r.toFixed(4)),t.res.headers.append("server-timing",o),s=r>1e3?0:r>100?1:r>10?2:3;const n={t:r.toFixed(s)};let a=`[${t.ip}] ${t.status} ${t.method} ${t.path}`;const d=t.logger,p=r>t.settings.LOG_SLOW_REQUEST_IN_MILLISECONDS;if(t.verbose||p){n.headers=function(e){const t=e.toJSON(),i={};for(const[e,s]of Object.entries(t))s.length&&(i[e]=s.length>1?s:s[0]);return i}(t.req.headers);try{n.identity=t.identity}catch(e){n.identity={__xXx__:e.message}}if(Object.keys(t.params).length&&(n.params=t.params),Object.keys(t.query).length&&(n.query=t.query),"POST"===t.method||"PUT"===t.method)try{n.body=await t.req.json()}catch(e){n.body={__xXx__:e.message}}}p&&(n.slow=1);const c=t.error;c?(c instanceof e&&(c.code&&(n.code=c.code),c.context&&(n.context=c.context)),d.error(c,n,a)):t.state.silent?d.trace(n,a):d.info(n,a)})}),this.addMiddleware(function(t,i){return i().then(e=>{const i=t.res;void 0===i.body&&(e instanceof v||Buffer.isBuffer(e)?i.body=e:i.body=function(e){return Array.isArray(e)?{ok:1,results:e}:void 0!==e?{ok:1,result:e}:{ok:1}}(e)),void 0===i.status&&(i.status=200),h(t)}).catch(i=>{t.error=i;const{statusCode:s,statusMessage:r,headers:o,body:a}=function(t,i){let s,r,o=500,a="Server Exception";return i instanceof Error?i instanceof e?(i instanceof n&&(i.headers&&(s=i.headers),i.statusCode&&(o=i.statusCode),i.statusMessage&&(a=i.statusMessage)),r=Object.assign({},i.toJSON(),{ok:0})):r={ok:0,error:i.name,message:i.message,stack:i.stack}:r={ok:0},{statusCode:o,statusMessage:a,headers:s,body:r}}(0,i);o&&t.res.setHeaders(o),null!=a&&(t.res.body=a),t.res.statusCode=s,t.res.statusMessage=r})}),this.addMiddleware(function(e,i){const s=`REQ/${Date.now()}`;e.req.logger.update({req_id:s}),e.setHeader("x-request-id",s),e.setHeader("x-request-count",String(e.req.id)),e.performance.log("router","[[LookupRoute]]");const r=t.router.search(e.method,e.path);return r&&(e.req.params=r.params,r.handler&&"function"==typeof r.handler)?r.handler(e):i()}),this.onInitApplication(),this.settings.PUBLIC_DIR?(this.logger.warn(`Serving files from ${this.settings.PUBLIC_DIR}`),this.addMiddleware(function(e,t){if("GET"===e.method){e.performance.log("router","[[ServeStaticFile]]");try{q(e,e.path)||(e.status=404,e.body={ok:0,message:"File Not Found"})}catch(t){e.logger.error(t,"send file")}}else e.status=405,e.body={ok:0,message:"Method Not Allowed"};return t()})):this.addMiddleware(function(e,t){return"GET"===e.method?(e.status=404,e.body={ok:0,message:"Route Not Found"}):(e.status=405,e.body={ok:0,message:"Method Not Allowed"}),t()})}}U([S(),W("design:type",s)],WebFoundationApplication.prototype,"middleware",void 0);class WebFoundationSettings extends f{constructor(){super(...arguments),this.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS=600,this.LOG_SLOW_REQUEST_IN_MILLISECONDS=1e4,this.WEB_DEVICE_COOKIE_KEY="__xXx__",this.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS=3456e4,this.WEB_SESSION_COOKIE_KEY="__xXx__",this.WEB_SESSION_COOKIE_EXPIRES_IN_SECONDS=1800,this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_CONTENT_SECURITY_POLICY=["script-src","'self'"],this.TRUSTED_EMAIL_PROVIDERS=[],this.THEME="default",this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[],this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e4,this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/"}}class FormField{}class FileField extends FormField{}class TextField extends FormField{}class WebForm extends Array{prepare(){if(!this.texts||!this.files){this.texts=new Map,this.files=new Map;for(const e of this)if(e instanceof TextField){let t=this.texts.get(e.name);t||(t=[],this.texts.set(e.name,t)),t.push(e.value)}else if(e instanceof FileField){let t=this.files.get(e.name);t||(t=[],this.files.set(e.name,t)),t.push(e)}}}getText(e){this.prepare();let t=this.texts.get(e);return t&&t[0]}getFile(e){if(this.prepare(),"string"==typeof e){let t=this.files.get(e);return t&&t[0]}for(const e of this.files.values())return e[0]}getFiles(e){if(this.prepare(),"string"==typeof e)return this.files.get(e)||[];let t=[];for(const e of this.files.values())t=t.concat(...e);return t}}class WebFoundationService extends r{}let K=class ExternalProviderModel extends D{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};U([L(),W("design:type",String)],K.prototype,"provider",void 0),U([L(),W("design:type",String)],K.prototype,"providerProtocol",void 0),U([L(),W("design:type",String)],K.prototype,"providerURL",void 0),U([L(),W("design:type",String)],K.prototype,"providerFingerprint",void 0),U([L(),W("design:type",Object)],K.prototype,"providerConfiguration",void 0),U([L(),W("design:type",String)],K.prototype,"appID",void 0),U([L(),W("design:type",String)],K.prototype,"appSecret",void 0),U([L(),W("design:type",String)],K.prototype,"scope",void 0),U([L(),W("design:type",String)],K.prototype,"displayName",void 0),U([L(),W("design:type",String)],K.prototype,"displayImageURL",void 0),U([L(),W("design:type",String)],K.prototype,"description",void 0),K=U([P("ExternalProvider")],K);class ExternalProviderCollection extends M{constructor(){super(K)}}class ExternalProviderService extends WebFoundationService{async findOrCreateExternalProvider(e,t){console.log("2222");const i=o({provider:t.provider,providerProtocol:t.providerProtocol,providerURL:t.providerURL}),s=await e.resolve(ExternalProviderCollection),r=await s.get(i);return r||s.add(i,t).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}}let G=class ExternalUserModel extends D{};U([L(),W("design:type",Object)],G.prototype,"uid",void 0),U([L(),W("design:type",String)],G.prototype,"provider",void 0),U([L(),W("design:type",String)],G.prototype,"providerProtocol",void 0),U([L(),W("design:type",String)],G.prototype,"providerURL",void 0),U([L(),W("design:type",String)],G.prototype,"providerId",void 0),U([L(),W("design:type",String)],G.prototype,"providerData",void 0),U([L(),W("design:type",String)],G.prototype,"userData",void 0),U([L(),W("design:type",String)],G.prototype,"user",void 0),U([L(),W("design:type",String)],G.prototype,"username",void 0),U([L(),W("design:type",String)],G.prototype,"domain",void 0),U([L(),W("design:type",Object)],G.prototype,"email",void 0),U([L(),W("design:type",Boolean)],G.prototype,"emailCertified",void 0),U([L(),W("design:type",Object)],G.prototype,"mobile",void 0),U([L(),W("design:type",Boolean)],G.prototype,"mobileCertified",void 0),U([L(),W("design:type",String)],G.prototype,"displayName",void 0),U([L(),W("design:type",String)],G.prototype,"displayImageURL",void 0),U([L(),W("design:type",String)],G.prototype,"displayImageFile",void 0),U([L(),W("design:type",Object)],G.prototype,"familyName",void 0),U([L(),W("design:type",Object)],G.prototype,"givenName",void 0),U([L(),W("design:type",Object)],G.prototype,"gender",void 0),U([L(),W("design:type",Object)],G.prototype,"dob",void 0),U([L(),W("design:type",Object)],G.prototype,"status",void 0),U([L(),W("design:type",Object)],G.prototype,"bio",void 0),U([L(),W("design:type",Object)],G.prototype,"homepage",void 0),U([L(),W("design:type",Object)],G.prototype,"locale",void 0),G=U([P("external_user")],G);class ExternalUserCollection extends M{constructor(){super(G)}}class ExternalUserService extends WebFoundationService{async findOrCreateExternalUser(e,t,i){const s=await e.resolve(ExternalUserCollection),r=await s.get(t);return r||s.add(t,i).then(e=>{if(!e)throw new Error("Unable to create external user");return e})}}class WebFoundationController extends r{}class BotService extends WebFoundationService{dispatch(e,t){console.log("dispatch",t)}}class Random{static generateRandomNumber(e){const t=Math.pow(10,e-1),i=Math.pow(10,e);return Math.floor(Math.random()*(i-t)+t)}static generateRandomToken(e){const t=[],i=this.POOL,s=this.MAX;for(let r=0;r<e;r++){const e=Math.floor(Math.random()*s);t.push(i[e])}return t.join("")}}Random.POOL="2346789BbCcDdFfGgHhJjKkMmPpQqRrTtVvWwXxYy",Random.MAX=Random.POOL.length;class MessageIdentity extends WebFoundationRequestIdentity{}class TelegramMessageIdentity extends MessageIdentity{static[_](e,[t]){let i=`${t.first_name}`;t.last_name&&(i+=` ${t.last_name}`);const s={uid:t.id,providerId:"3fdeba596a7d938a05c38daf"},r=o(s).toHexString(),n=new TelegramMessageIdentity;return n.id=t.id,n.address=IdentityHelper.createIdentityAddress(e)+"/tg/"+t.id,n.user=r,n.profile={_id:r,id:t.username,displayName:i,displayImageURL:""},t.is_bot&&(n.profile.bot=t.is_bot),n.theme=n.theme||e.settings.THEME,n.locale=t.language_code||e.settings.LOCALE,n.timezone=n.timezone||e.settings.TIMEZONE,n}}let Y=class TelegramBotController extends WebFoundationController{async telegram(e){if(!e.params.token)throw new c("Missing bot token for telegram");if(e.settings.TELEGRAM_BOT_TOKEN!=e.params.token)throw new c("Invalid bot token");const t=await e.json(),i=t.channelData||t,s=await e.resolve(TelegramMessageIdentity,function(e){const t=e.message||e.callback_query||e.edited_message||e.pre_checkout_query;let i;if(t)i=t.from;else{const t=Object.keys(e),s=t.find(t=>!!e[t].from);if(!s)throw new c(`Unable to find 'from' field in message: ${t}`);i=e[s].from}return[i,t,e]}(i));let r,o,n,a;if(i.message)o=(r=i.message).chat,a=r.text,n=new Date(1e3*r.date);else if(i.callback_query)o=(r=i.callback_query.message).chat,a=i.callback_query.data,n=new Date(1e3*r.date);else{if(!i.pre_checkout_query)return i.edited_message?(this.logger.debug({sourceEvent:i},"Edit message is ignored in this version"),void(e.body=null)):(this.logger.error({sourceEvent:i},"Unknown message type"),void(e.body=null));{const e=i.pre_checkout_query.from;o={id:e.id,first_name:e.first_name,last_name:e.last_name,username:e.username,type:"private"},a=i.pre_checkout_query.invoice_payload,n=new Date}}const d={id:Random.generateRandomToken(10),type:"message",identity:s,timestamp:n,from:{id:s.id,name:s.profile.displayName},conversation:{isGroup:"private"!==o.type,id:o.id},recipient:{id:e.settings.TELEGRAM_BOT_ID,name:e.settings.NAME},channelId:"telegram",channelData:i,text:a};this.bot.dispatch(e,d)}};U([I(),W("design:type",BotService)],Y.prototype,"bot",void 0),U([m("POST","/update/:token"),W("design:type",Function),W("design:paramtypes",[Object]),W("design:returntype",Promise)],Y.prototype,"telegram",null),Y=U([E("/api/integration/telegram/bot")],Y);export{WebFoundationApplication,WebFoundationSettings,FormField,TextField,FileField,WebForm,ExternalProviderService,ExternalUserService,Y as TelegramBotController,BotService};
//# sourceMappingURL=index.mjs.map
